//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class MonteCarloMembraneBarostat : Force {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;

  internal MonteCarloMembraneBarostat(global::System.IntPtr cPtr, bool cMemoryOwn) : base(OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_SWIGUpcast(cPtr), cMemoryOwn) {
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(MonteCarloMembraneBarostat obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~MonteCarloMembraneBarostat() {
    Dispose();
  }

  public override void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_MonteCarloMembraneBarostat(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
      base.Dispose();
    }
  }

  public static string Pressure() {
    string ret = OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_Pressure();
    return ret;
  }

  public static string SurfaceTension() {
    string ret = OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_SurfaceTension();
    return ret;
  }

  public static string Temperature() {
    string ret = OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_Temperature();
    return ret;
  }

  public MonteCarloMembraneBarostat(double defaultPressure, double defaultSurfaceTension, double defaultTemperature, MonteCarloMembraneBarostat.XYMode xymode, MonteCarloMembraneBarostat.ZMode zmode, int frequency) : this(OpenMMSwigPINVOKE.new_MonteCarloMembraneBarostat__SWIG_0(defaultPressure, defaultSurfaceTension, defaultTemperature, (int)xymode, (int)zmode, frequency), true) {
  }

  public MonteCarloMembraneBarostat(double defaultPressure, double defaultSurfaceTension, double defaultTemperature, MonteCarloMembraneBarostat.XYMode xymode, MonteCarloMembraneBarostat.ZMode zmode) : this(OpenMMSwigPINVOKE.new_MonteCarloMembraneBarostat__SWIG_1(defaultPressure, defaultSurfaceTension, defaultTemperature, (int)xymode, (int)zmode), true) {
  }

  public double getDefaultPressure() {
    double ret = OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_getDefaultPressure(swigCPtr);
    return ret;
  }

  public void setDefaultPressure(double pressure) {
    OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_setDefaultPressure(swigCPtr, pressure);
  }

  public double getDefaultSurfaceTension() {
    double ret = OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_getDefaultSurfaceTension(swigCPtr);
    return ret;
  }

  public void setDefaultSurfaceTension(double surfaceTension) {
    OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_setDefaultSurfaceTension(swigCPtr, surfaceTension);
  }

  public int getFrequency() {
    int ret = OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_getFrequency(swigCPtr);
    return ret;
  }

  public void setFrequency(int freq) {
    OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_setFrequency(swigCPtr, freq);
  }

  public double getDefaultTemperature() {
    double ret = OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_getDefaultTemperature(swigCPtr);
    return ret;
  }

  public void setDefaultTemperature(double temp) {
    OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_setDefaultTemperature(swigCPtr, temp);
  }

  public MonteCarloMembraneBarostat.XYMode getXYMode() {
    MonteCarloMembraneBarostat.XYMode ret = (MonteCarloMembraneBarostat.XYMode)OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_getXYMode(swigCPtr);
    return ret;
  }

  public void setXYMode(MonteCarloMembraneBarostat.XYMode mode) {
    OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_setXYMode(swigCPtr, (int)mode);
  }

  public MonteCarloMembraneBarostat.ZMode getZMode() {
    MonteCarloMembraneBarostat.ZMode ret = (MonteCarloMembraneBarostat.ZMode)OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_getZMode(swigCPtr);
    return ret;
  }

  public void setZMode(MonteCarloMembraneBarostat.ZMode mode) {
    OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_setZMode(swigCPtr, (int)mode);
  }

  public int getRandomNumberSeed() {
    int ret = OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_getRandomNumberSeed(swigCPtr);
    return ret;
  }

  public void setRandomNumberSeed(int seed) {
    OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_setRandomNumberSeed(swigCPtr, seed);
  }

  public override bool usesPeriodicBoundaryConditions() {
    bool ret = OpenMMSwigPINVOKE.MonteCarloMembraneBarostat_usesPeriodicBoundaryConditions(swigCPtr);
    return ret;
  }

  public enum XYMode {
    XYIsotropic = 0,
    XYAnisotropic = 1
  }

  public enum ZMode {
    ZFree = 0,
    ZFixed = 1,
    ConstantVolume = 2
  }

}

}
